*** GPX-aus-SHP.prg ***
*** Version Januar 2022, ergnzt um Handling der Umgebungsvariable PROJ_PATH
*** Erzeugt aus einem Shapefile (25832)
*** einen topologisch korrekten GPX-Track
*** Rainer Maria Kreten, Nationalparkamt Hunsrck-Hochwald
*** 2021, 2022
#include "minigui.ch"
Function Main
public mtrackname := ''
public mtrackautor := ''
public mtrackdesc := ''
public mprojdb := ' '
public mmindistanz := 4
public mverzeichnis := diskname() + ":" + dirname() + "\"
public mausdatei := ""
public mvalue := '1'
public madateiliste := array(0)
public mafiles := array(0)

set century on
set date german
set language to german
set codepage to german
set multiple off
mdatei := ""
if file('GPX-aus-SHP.ini') // ini-Werte einlesen
   mtrackname  = token(filestr('GPX-aus-SHP.ini'),'#',1)
   mtrackautor = token(filestr('GPX-aus-SHP.ini'),'#',2)
   mtrackdesc  = token(filestr('GPX-aus-SHP.ini'),'#',3)
   mprojdb     = token(filestr('GPX-aus-SHP.ini'),'#',4)
endif
   
select 1

    DEFINE WINDOW Win_1 ;
        AT 0,0 ;
        WIDTH 700 ;
        HEIGHT 500 ;
        TITLE 'Erzeugen eines GPX-Tracks Version 1.2 Januar 2022' ;
        MAIN ;
		          ON INIT fprojpath()

        DEFINE MAIN MENU
           POPUP "Datei"
             ITEM 'Shapefile auswhlen' ACTION fdateiauswahl()
			 ITEM 'Zieldatei (GPX) auswhlen' ACTION fausgabe()
			 SEPARATOR
			 ITEM 'Konvertierung durchfhren' ACTION fumwandlung()
			 SEPARATOR
			 ITEM 'Programm Ende' ACTION fende()
            END POPUP
           POPUP "Hilfe"
             item 'Hilfedatei lesen' ACTION fhilfe()
             item 'ber ...' ACTION msgbox("Ein Programm zur digitalen Besucherlenkung aus dem Nationalpark Hunsrck-Hochwald 2021, 2022")
           END POPUP
		       @ -15,350 IMAGE Image_1 ;
            PICTURE 'NLPLOGO.jpg';
            WIDTH 300 ;
            HEIGHT 150 
 
        END MENU
 
    @ 120,20 LABEL Label_10 VALUE 'Name des Tracks '
    @ 150,20 LABEL LABEL_11 VALUE 'Autor           '
    @ 180,20 LABEL LABEL_12 VALUE 'Beschreibung    '
	
	@ 120,150 textbox EDIT_10 WIDTH 500 HEIGHT 20 VALUE mtrackname  ON change mtrackname  := this.value 
	@ 150,150 textbox EDIT_11 WIDTH 500 HEIGHT 20 VALUE mtrackautor ON change mtrackautor := this.value 
	@ 180,150 textbox EDIT_12 WIDTH 500 HEIGHT 20 VALUE mtrackdesc  ON change mtrackdesc  := this.value 
 

    @ 240,20 LABEL Label_1 VALUE  'Shapefile       '    
    @ 280,20 LABEL Label_2 VALUE  'Zieldatei       '    
    @ 320,20 LABEL Label_3 VALUE  'Sttzpunkte     '    
    @ 360,20 LABEL Label_4 VALUE  'min. Abstand [m]'
    @ 360,150 SPINNER SPINNER_1 RANGE 1,360 VALUE 4 WIDTH 60 HEIGHT 20  ON CHANGE mmindistanz := this.value INCREMENT 1


    END WINDOW

    ACTIVATE WINDOW Win_1
Return
// Ende GUI
//####################################################################################################
// Funktionen
Function fprojpath()
// Pfad zu proj.db ermitteln

if .not. file(mprojdb)
   @210,150 LABEL LABEL_20 of WIN_1 VALUE 'Bitte warten, die Datei PROJ.DB zur Koordinatenumrechnung wird gesucht...' WIDTH 500 BOLD

   maFiles := DirectoryRecurse('C:\proj.db')
   i := len(mafiles)
   do while i > 0
     aadd(madateiliste,mafiles[i,1])
     i --
   enddo	  

  @ 240,150 LISTBOX LIST_1 PARENT WIN_1 width 500 height 120 ITEMS madateiliste VALUE 1 ON CHANGE mvalue := str(WIN_1.LIST_1.value)
  
  @ 380,550 BUTTON BUTTON_20 OF WIN_1 CAPTION 'OK' ON CLICK fprojpathende()  WIDTH 100 HEIGHT 50 BOLD

endif
// WIN_1.LIST_1.release
return
function fprojpathende()
mprojdb = madateiliste[val(mvalue)]
Win_1.Label_20.release
win_1.button_20.release
win_1.List_1.release
asize(madateiliste,0)
asize(mafiles,0)
return
//####################################################################################################################################
Function fumwandlung()  // Hauptprogrammschleife
strfile(mtrackname + '#' + mtrackautor + '#' + mtrackdesc + '#' + mprojdb, 'GPX-aus-SHP.ini') // Speichern der Metadaten
fdbferzeugen()
// Pruefungen /////
use gpxausshp
if reccount() < 10
   msginfo('Zu wenige Sttzpunkte, bitte Quelldaten prfen!','Fehlermeldung')
   return
endif
locate for alltrim(upper(startstop)) = 'START'
if eof()
   msginfo('Kein Startpunkt eingetragen!','Fehlermeldung')
   fende()
   return
endif
locate for alltrim(upper(startstop)) = 'STOP'
if eof()
   msginfo('Kein Endpunkt eingetragen!','Fehlermeldung')
   fende()
   return
endif
if len(mausdatei) < 11 .or. upper(right(mausdatei,4)) <> '.GPX'
   msginfo('Keine gltige Ausgabedatei angegeben!','Fehlermeldung')
   return
endif
use
fgpxtrack()
fhoehenprofil()
return

// Ende Hauptschleife////////////////////////////
Function fausgabe
madateimaske = array(2)
mausdatei = ""
afill (madateimaske, {"*.gpx" , "*.GPX"})
mausdatei=putfile(madateimaske,"GPX-Dateien",mverzeichnis,.F.)
if iscontroldefined(LABEL_9,Win_1)
   win_1.LABEL_9.release
endif
@ 280,150 LABEL LABEL_9 PARENT Win_1 width 500 rightalign VALUE  mausdatei
Win_1.Label_9.fontbold := .T.
dirchange(mverzeichnis)

return
///////////////////////////
Function fdateiauswahl
madateimaske = array(2)
mdatei = ""
afill (madateimaske, {"*.shp" , "*.SHP"})
mdatei=getfile(madateimaske,"Shapefiles",mverzeichnis,.F.,.F.)
dirchange(mverzeichnis)
if iscontroldefined(LABEL_8,Win_1)
   win_1.LABEL_8.release
endif
@ 240,150 LABEL LABEL_8 PARENT Win_1 width 500 Height 30 rightalign VALUE  mdatei

Win_1.Label_8.fontbold := .T.
fdummy()
return
////////////////////////////
function fhilfe
mhilfedatei = mverzeichnis + "GPX-aus-SHP_Hilfe.pdf"
if file(mhilfedatei)
   execute file mhilfedatei 
else
   msginfo("Die Hilfedatei fehlt!","Horrormeldung")
endif
return
/////////////////////////////
function fdbferzeugen()
setcurrentfolder(mverzeichnis) 
set print to csverzeugen.bat
set print on
?? "@echo off"
? "REM Umbegungsvariable PROJ_PATH setzen"
? "SET PROJ_PATH=" + beforatnum('\',mprojdb) // nur den Pfad ohne Dateiname
? "SET PROJ_LIB=" + beforatnum('\',mprojdb)
? "REM Daten aus vorangegangenen Laeufen loeschen"
? 'del GPXausSHP.csv'
? 'del inputshape.???'
? 'REM Eingabe-Shapefile kopieren'
? 'xcopy "' + substr(mdatei,1,rat('.',mdatei)-1) +  '.???"  .\inputshape.???'
? 'REM CSV-Datei mit ogr2ogr aus Shapefeile erzeugen'
? 'ogr2ogr -f "csv" GPXausSHP.csv  inputshape.shp'
?? ' -dialect sqlite '
?? ' -sql "select segid, startstop AS startstop, round(ST_X(geometry),0) AS x, round(ST_y(geometry),0) AS y, round(ST_z(geometry),0) AS z, ST_X (ST_Transform (geometry, 4326)) AS longitude, ST_Y (ST_Transform (geometry, 4326)) AS latitude '
?? ' from inputshape" -skipfailures -lco SEPARATOR=COMMA -lco CREATE_CSVT=NO '
? 'REM pause'
?
set print off
set print to
EXECUTE file "csverzeugen.bat" wait
if filesize("GPXausSHP.csv") < 10
   msginfo("Aufruf von OGR2OGR gescheitert - Daten, Pfad?","Fehlermeldung")
   fende()
   return
endif
use GPXausSHP
zap
append from GPXausSHP.csv for x > 0 Delimited
if iscontroldefined(LABEL_5,Win_1)
   win_1.LABEL_5.release
endif
@ 320,150 LABEL LABEL_5 PARENT Win_1 width 350 VALUE  alltrim(str(reccount(),7,0))
Win_1.Label_5.fontbold := .T.
use
return
/////////////////////////////////////////////
function fgpxtrack()
use GPXausSHP
mx = 0
my = 0
set print to ausgabe.gpx
set print on
// Kopfdaten
?? '<?xml version="1.0" encoding="UTF-8" standalone="no" ?><gpx xmlns="http://www.topografix.com/GPX/1/1" version="1.1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd" creator="GPX.aus.SHP">'
// Namen bilden
? '<trk><name>' +  alltrim(mtrackname) + '</name>'
? '<author>' +  alltrim(mtrackautor) + '</author>'
? '<desc>' +  alltrim(mtrackdesc) + '</desc>'

? '<trkseg>'
// ?? 'longitude,latitude,distanz,lfdnr'
index on segid to reihenfolge
manzahl = 0
mdistanz = 10000
mrichtung = 1
mrecno = 1
mlfdnr = 0
replace all anzahl with 0
replace all lfdnr with 0
replace all distanz with 10000
locate for upper(alltrim(startstop)) = "START"

msegid = segid
do while manzahl < reccount()
   mrecno = recno()
   mx = x
   my = y
**   go top
   dbseek(msegid)
   do while segid = msegid 
      if mdistanz > sqrt(((mx - x)**2 + (my-y)**2)) .and. anzahl = 0 
         mdistanz = sqrt(((mx - x)**2 + (my-y)**2))
		 mrecno = recno()
      endif
      skip
   enddo
   goto mrecno
   replace Anzahl with anzahl + 1
   replace distanz with mdistanz
   mlfdnr ++
   replace lfdnr with mlfdnr
   if upper(startstop) <> 'START' .and. distanz > mmindistanz .and. distanz <> 10000
         ? '<trkpt lat="' + alltrim(str(latitude,9,6)) + '" lon="' + alltrim(str(longitude,9,6)) + '">'
         if Z <> 0
		    ?? '<ele>"' + alltrim(str(z,9,2)) + '"</ele>'
		 endif
         ?? '</trkpt>'
    endif
   if anzahl > reccount() .or. upper(startstop) = 'STOP'
      exit
	endif
    if distanz = 10000
	   go top
	   do while .not. eof()
	       if mdistanz > sqrt(((mx - x)**2 + (my-y)**2)) .and. anzahl = 0 .and. msegid <> segid
              mdistanz = sqrt(((mx - x)**2 + (my-y)**2))
		      mrecno = recno()
           endif
           skip
       enddo
       goto mrecno
	   msegid = segid
   endif	   
   mdistanz = 10000
enddo
? '</trkseg></trk></gpx>'
?
set print off
set print to
use
filedelete("Reihenfolge.ntx")
filecopy(mverzeichnis + 'Ausgabe.gpx',mausdatei)
msginfo('Konvertierung erfolgt - bitte Daten prfen','Fertigmeldung')
return
////////////////////////////////////////////////////////////////////////////
function fhoehenprofil()
dirchange(mverzeichnis)
set print to hoehenprofil.csv
set print on
mlfdnr := 0
?? "lfdnr,Distanz,Hoehe,Steigung"
use gpxausshp
index on lfdnr to Hoehenprofil
set filter to anzahl = 1
go bottom
go top
mx = x
my = y
mz = z
mgesamtdistanz = 0
do while .not. eof()
   skip
   mhdiff = z - mz
   mdist = sqrt((mx - x)**2 + (my - y)**2)
   mgesamtdistanz = mgesamtdistanz + mdist
   mlfdnr ++
   if .not. eof()
     ? strzero(mlfdnr,5,0) + "," + strzero(mgesamtdistanz,7,0) + "," +strzero(z,5,0)+ "," + strzero((mhdiff / mdist) * 100,4,0)
      mx = x
      my = y
      mz = z
   endif
enddo
?
set print off
set print to
use
filedelete("hoehenprofil.ntx")
return
///////////////////////////////////////////////////////////////////////////
function fende()
commit
use
quit
return
///////////////////////////////////////////////////////////////////////////

function fdummy
Return
